package com.eactive.eai.agent.b2badaptermapping;

import com.eactive.eai.agent.command.Command;
import com.eactive.eai.agent.command.CommandException;
import com.eactive.eai.common.b2badaptermapping.B2BAdapterMapManager;
import com.eactive.eai.common.util.Logger;

public class ReloadB2BAdapterMapCommand extends Command {

	private static final long serialVersionUID = 1L;

	public ReloadB2BAdapterMapCommand() {
		super("ReloadB2BAdapterMapCommand");
	}

	public Object execute() throws CommandException {
		Logger logger = Logger.getLogger(Logger.LOGGER_DEFAULT);
		if (logger.isInfo())
			logger.info(this.name + " is executed");

		if (!(args instanceof String)) {
			String rspErrorCode = "RECEAIMCM001";
			String msg = makeException(rspErrorCode, null);
			if (logger.isError())
				logger.error(msg);
			throw new CommandException(msg);
		}

		try {
			B2BAdapterMapManager manager = B2BAdapterMapManager.getInstance();
			String keyName = (String) args;

			if ("ALL".equals(keyName)) {
				manager.reload();
				logger.warn(this.name + ": all rule Reload.");
			} else {
				manager.reload(keyName);
				logger.warn(this.name + ": " + keyName + " Reload.");
			}

		} catch (Exception e) {
			String rspErrorCode = "RECEAIMCM002";
			String msg = makeException(rspErrorCode, e);

			if (logger.isError())
				logger.error(msg, e);
			throw new CommandException(msg);
		}
		return "success";

	}
}
